#pragma once
#include "Rect.hpp"
#include "ImageRect.hpp"


namespace JUI {
    struct DataPoint {
        Vector2 pos;
        Color4 color;
    };

    class Graph : public JUI::ImageRect {
    public:
    protected:
    private:
    };

    class FpsGraph : public JUI::ImageRect
    {
    public:

        void RenderDataPoints() {
            J2D::Begin(canvas, true);



            DataPoint prev = data[0];
            for (auto& data_pt : data) {

                //J2D::DrawGradientLine(prev.color, data_pt.color, prev.pos, data_pt.pos, 1);
                J2D::DrawLine(data_pt.color, data_pt.pos, {data_pt.pos.x, GetAbsoluteSize().y }, 1);

                prev = data_pt;
            }
            float target_line_height = (1.f / 60.f) * 1000;
            J2D::DrawString(Colors::Black, "60 FPS / 16.7ms (Target)", 0, 100 - target_line_height, 1.f, 10);
            J2D::DrawLine(Colors::White, {0, 100 - target_line_height}, {GetAbsoluteSize().x, 100 - target_line_height}, 1);
            J2D::End();
        }

        FpsGraph() : JUI::ImageRect() {
            for (int i = 0; i < 500; i++) {
                Plot({i / 1.f, 0.f}, Colors::Black);
            }

            canvas = new JGL::RenderTarget({500, 100});

            RenderDataPoints();

            Content(canvas);
        };
        explicit FpsGraph(Widget* parent) : FpsGraph() {
            Parent(parent);


        }
        void Plot(const Vector2& pt, const Color4& col) {
            data.push_back(DataPoint{ pt, col });
        }

        void Update(float delta) override {
            ImageRect::Update(delta);
            data.erase(data.begin());
            for (auto& data_pt : data) {
                data_pt.pos.x -= 1;
            }

            Color4 color = Colors::Green;
            if (delta > 1e-3f)
                color = Colors::Blue;
            if (delta > 1e-2f)
                color = Colors::Yellow;
            if (delta > 1e-1f)
                color = Colors::Red;
            if (delta > 1e+1f)
                color = Colors::Purples::Magenta;
            if (delta > 1e+2f)
                color = Colors::Black;


            Plot({(data.size()-1.f),  100 - (delta*1000)}, color);

            RenderDataPoints();
            Content(canvas);
        }

        std::vector<DataPoint> data;
        JGL::RenderTarget* canvas;

    protected:
    private:
    };
}